unit uBase64Test0;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    m1: TMemo;
    m2: TMemo;
    bEncode: TButton;
    bDecode: TButton;
    procedure bEncodeClick(Sender: TObject);
    procedure bDecodeClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}


procedure TForm1.bEncodeClick(Sender: TObject);
const
  chr64 : array[0..63] of char =
             ('A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M',
              'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z',
              'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm',
              'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z',
              '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '+', '/');
var
  s1,s2                : string;
  i,n                  : integer;
  a1,a2,a3,b1,b2,b3,b4 : byte;
  chr1,chr2,chr3,chr4  : char;
begin
  s1 := m1.Lines.Text;

  s2 := '';
  n := Length(s1);
  i := 1;
  while i <= n-2 do
  begin
    a1 := ord(s1[i]);
    a2 := ord(s1[i+1]);
    a3 := ord(s1[i+2]);
    b1 := (a1 and 252) shr 2;
    b2 := ((a1 and 3) shl 4) or ((a2 and 240) shr 4);
    b3 := ((a2 and 15) shl 2) or ((a3 and 192) shr 6);
    b4 := a3 and 63;
    chr1 := chr64[b1];
    chr2 := chr64[b2];
    chr3 := chr64[b3];
    chr4 := chr64[b4];
    s2 := s2+chr1+chr2+chr3+chr4;
    i := i+3;
  end;
  m2.Lines.Add(IntToStr(i));
  if i = n // 2 Fllbytes
  then
  begin
    a1 := ord(s1[n]);
    a2 := 0;
    a3 := 0;
    b1 := (a1 and 252) shr 2;
    b2 := ((a1 and 3) shl 4) or ((a2 and 240) shr 4);
    b3 := ((a2 and 15) shl 2) or ((a3 and 192) shr 6);
    b4 := a3 and 63;
    chr1 := chr64[b1];
    chr2 := chr64[b2];
    chr3 := '=';
    chr4 := '=';
    s2 := s2+chr1+chr2+chr3+chr4;
  end;
  if i = n-1 // 1 Fllbyte
  then
  begin
    a1 := ord(s1[n-1]);
    a2 := ord(s1[n]);
    a3 := 0;
    b1 := (a1 and 252) shr 2;
    b2 := ((a1 and 3) shl 4) or ((a2 and 240) shr 4);
    b3 := ((a2 and 15) shl 2) or ((a3 and 192) shr 6);
    b4 := a3 and 63;
    chr1 := chr64[b1];
    chr2 := chr64[b2];
    chr3 := chr64[b3];
    chr4 := '=';
    s2 := s2+chr1+chr2+chr3+chr4;
  end;

  m2.Lines.Text := s2;
end;

procedure TForm1.bDecodeClick(Sender: TObject);
var
  s1,s2                : string;
  i,n                  : integer;
  a1,a2,a3,b1,b2,b3,b4 : byte;

  function charToByte64(ch : char) : byte;
  begin
    if (ch >= 'A') and (ch <= 'Z')
    then
      result := ord(ch)-ord('A')
    else
       if (ch >= 'a') and (ch <= 'z')
       then
         result := ord(ch)-ord('a')+26
       else
         if (ch >= '0') and (ch <= '9')
         then
           result := ord(ch)-ord('0')+52
         else
           if ch = '+'
           then
             result := 62
           else
             if ch = '/'
             then
               result := 63
             else
               result := 255; // Fehlerfall
  end;

begin
  s2 := m2.Lines.Text;

  s1 := '';
  n := Length(s2);
  for i := 1 to n div 4 - 1 do
  begin
    b1 := charToByte64(s2[4*i-3]);
    b2 := charToByte64(s2[4*i-2]);
    b3 := charToByte64(s2[4*i-1]);
    b4 := charToByte64(s2[4*i]);
    a1 := (b1 shl 2) or ((b2 and 48) shr 4);
    a2 := ((b2 and 15) shl 4) or ((b3 and 60) shr 2);
    a3 := ((b3 and 3) shl 6) or b4;
    s1 := s1+chr(a1)+chr(a2)+chr(a3);
  end;
  if s2[n] <> '='
  then
  begin
    b1 := charToByte64(s2[n-3]);
    b2 := charToByte64(s2[n-2]);
    b3 := charToByte64(s2[n-1]);
    b4 := charToByte64(s2[n]);
    a1 := (b1 shl 2) or ((b2 and 48) shr 4);
    a2 := ((b2 and 15) shl 4) or ((b3 and 60) shr 2);
    a3 := ((b3 and 3) shl 6) or b4;
    s1 := s1+chr(a1)+chr(a2)+chr(a3);
  end
  else
    if s2[n-1] <> '='
    then
    begin
      b1 := charToByte64(s2[n-3]);
      b2 := charToByte64(s2[n-2]);
      b3 := charToByte64(s2[n-1]);
      a1 := (b1 shl 2) or ((b2 and 48) shr 4);
      a2 := ((b2 and 15) shl 4) or ((b3 and 60) shr 2);
      s1 := s1+chr(a1)+chr(a2);
    end
    else
    begin
      b1 := charToByte64(s2[n-3]);
      b2 := charToByte64(s2[n-2]);
      a1 := (b1 shl 2) or ((b2 and 48) shr 4);
      s1 := s1+chr(a1);
    end;

  m1.Lines.Text := s1;
end;


end.
